/* HDF-EOS support for the XML->HDF-EOS converter */
#include "HE5_HdfEosDef.h"
#include <stdio.h>

hid_t hdfeos_native_type(H5T_class_t class_type, int size, int signp);

/* we need a structure to hold a list of attributes, because HDF-EOS
   fields (data and geo) must be defined *after* the attributes have
   already been seen by expatish parsers.  Bleah.
*/
typedef struct attributestack {
  struct attributestack *next;
  char *name;
  hid_t type;
  hsize_t count;
  void *buffer;
} attributestack;

/* dimension map - saving an association between dimension names and sizes */

typedef struct dmap {
  struct dmap *next;
  hsize_t size;
  char *name;
} dmap;

void add_dimension (dmap **dm, char const *name, hsize_t size);
hsize_t find_dimension(dmap *dm, char const *name);
void recycle_dm(dmap **dm);
