/* support for simple and stupid error handling -
  if a call returns a bad status,
   just print the status, the statement that errored, and exit.  We'll
   have to do better in the future, of course...
*/

/* ANSI pre-processor macro substitution, gotta love it... */

#define SS(x) spit_status(x, #x "")

/* support.c declarations */
void spit_status(int stat, char const *call);
char *newstring(int len);
char *strclone(const char *in);
void free_safely(void *x);

/* Trace code support.  TRACE((stderr, "format string", args...)) */
#ifdef TRACE_OUTPUT
#define TRACE(x) fprintf x
#define TRACEWRAP(x) x
#else
#define TRACE(x)
#define TRACEWRAP(x)
#endif

/* turn this on to enable malloc/free tracing */
#ifdef TRACE_MALLOC
#define malloc(x) MYmalloc(x, __LINE__, __FILE__)
#define calloc(x,y) MYcalloc(x, y,  __LINE__, __FILE__)
#define free(x) MYfree(x, __LINE__, __FILE__)
void *MYmalloc(size_t size, int line, char *file);
char *MYcalloc(size_t nmemb, size_t size, int line, char *file);
void MYfree(void *ptr, int line, char *file);
#endif
