/* handles the callbacks for Dimension and its ilk */

#include "xml2he5.h"
#include <stdio.h>

#include "globals.h"

/* <!ELEMENT Dimension EMPTY> (attributes Name and Size) */

SEHdeclare(Dimension)
{
  XML_Char const *xc_name = FindAttribute("Name");
  XML_Char const *xc_size = FindAttribute("Size");

  TRACE((stderr, "Entering Dimension\n"));
  /* Whoever sent us here has set our end handler already */

  if(xc_name == NULL) {
    fprintf(stderr, "Dimension with no Name attribute\n");
    PrintXMLLocation();
    exit(-1);
  }
  dimension_name = strclone(xc_name);

  if(xc_size == NULL) {
    fprintf(stderr, "Dimension with no Size attribute\n");
    PrintXMLLocation();
    exit(-1);
  }
  if(!strcmp(xc_size, "SD_UNLIMITED")) {
    dimension_size = H5S_UNLIMITED;
  }
  else if(sscanf(xc_size, "%ld", &dimension_size) != 1
	  || dimension_size <= 0) {
    fprintf(stderr, "Not a valid number for Size: %s\n", GlobalCDATA.buffer);
    PrintXMLLocation();
    exit(-1);
  }
}
