/* Headers for the HDF-EOS 5 XML reader/file creator */

/* we're of course using HDF-EOS5 */
#include "HE5_HdfEosDef.h"

/* And expat_support, which includes expat.h*/
#include "expat_support.h"

/* and hdfeos-support */
#include "hdfeos-support.h"

/* and support.h */
#include "support.h"

/* predeclarations of the various callback functions */

/* These should be declared (and defined) in expar_support.c, say */
SEHdeclare(NoMore);
EEHdeclare(JustPop);

/* Most of these don't really have to be global - they could be defined
   local to the files where they are created.  But, I'm lazy...
*/
HandlerDeclare(HDFEOS_File);
HandlerDeclare(HDFEOS);
HandlerDeclare(HDFEOS_INFORMATION);
HandlerDeclare(FileAttribute);
HandlerDeclare(POINTS);
HandlerDeclare(SWATHS);
HandlerDeclare(Swath);
HandlerDeclare(SwathAttribute);
HandlerDeclare(SwathDimension);
HandlerDeclare(GRIDS);
HandlerDeclare(GeoField);
HandlerDeclare(DataField);

HandlerDeclare(Attribute);
HandlerDeclare(DataType);
HandlerDeclare(Count);
HandlerDeclare(intValue);
HandlerDeclare(floatValue);
HandlerDeclare(stringValue);
HandlerDeclare(IntegerType);
HandlerDeclare(FloatType);
HandlerDeclare(StringType);
HandlerDeclare(OtherType);

HandlerDeclare(Dimension);
HandlerDeclare(DimName);
HandlerDeclare(DimensionName);
HandlerDeclare(Size);
HandlerDeclare(GeoFieldAttribute);
HandlerDeclare(GeoFieldDataType);
HandlerDeclare(GeoFieldDimList);
HandlerDeclare(GeoFieldMaxDimList);
HandlerDeclare(GeoFieldFieldStorage);
HandlerDeclare(GeoFieldlink_to_data);
HandlerDeclare(GeoFieldin_line_data);
HandlerDeclare(DataFieldAttribute);
HandlerDeclare(DataFieldDataType);
HandlerDeclare(DataFieldDimList);
HandlerDeclare(DataFieldMaxDimList);
HandlerDeclare(DataFieldFieldStorage);
HandlerDeclare(DataFieldlink_to_data);
HandlerDeclare(DataFieldin_line_data);

HandlerDeclare(FieldAttribute);
HandlerDeclare(AttributeDataType);
HandlerDeclare(DimensionMapping);

HandlerDeclare(FieldStorage);
HandlerDeclare(Merge);
HandlerDeclare(Compression);
HandlerDeclare(CompParameter);

HandlerDeclare(RegularDimensionMapping);
HandlerDeclare(RDGeoDimension);
HandlerDeclare(RDDataDimension);
HandlerDeclare(Offset);
HandlerDeclare(Increment);
HandlerDeclare(IDGeoDimension);
HandlerDeclare(IDDataDimension);
HandlerDeclare(IndexArray);

HandlerDeclare(IndexDimensionMapping);

/* The stuff in/needed by x2h-grids.c */
HandlerDeclare(Grid);
HandlerDeclare(Parameters);
HandlerDeclare(GridAttribute);
HandlerDeclare(GridDataAttribute);
HandlerDeclare(GridDataDataType);
HandlerDeclare(GridDataDimList);
HandlerDeclare(GridDataMaxDimList);
HandlerDeclare(GridDataFieldStorage);
